
/*  A Bison parser, made from read_eqn.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	OPR_OR	258
#define	OPR_AND	259
#define	CONST_ZERO	260
#define	CONST_ONE	261
#define	IDENTIFIER	262
#define	LPAREN	263
#define	OPR_XOR	264
#define	OPR_XNOR	265
#define	OPR_NOT	266
#define	OPR_NOT_POST	267
#define	NAME	268
#define	INORDER	269
#define	OUTORDER	270
#define	PASS	271
#define	ASSIGN	272
#define	SEMI	273
#define	RPAREN	274
#define	END	275

#line 10 "read_eqn.y"

#include "sis.h"
#include "io_int.h"
#include <setjmp.h>

#ifdef YYBYACC
extern char *yytext;
#else
#if defined(hpux) || defined(__osf__)
extern unsigned char yytext[];
#else
extern char yytext[];
#endif
#endif

static network_t *global_network;
static lsList po_list;

static int yyerror();
#ifndef FLEX_SCANNER
#undef yywrap
static int input();
static int unput();
static int yywrap();
#endif


static void
do_assign(name, expr)
char *name;
node_t *expr;
{
    char errmsg[1024];
    node_t *node;

    node = read_find_or_create_node(global_network, name);
    if (node_function(node) != NODE_UNDEFINED) {
	(void) sprintf(errmsg, "Attempt to redefine '%s'\n", name);
	yyerror(errmsg);   /* never returns */
    }
    FREE(name);
    node_replace(node, expr);
}


static node_t *
do_sexpr_list(list, func)
array_t *list;
node_t *(*func)();
{
    int i;
    node_t *node, *node1, *node2;

    node1 = array_fetch(node_t *, list, 0);
    node = node_dup(node1);
    node_free(node1);
    for(i = 1; i < array_n(list); i++) {
	node1 = node;
	node2 = array_fetch(node_t *, list, i);
	node = (*func)(node1, node2);
	node_free(node1);
	node_free(node2);
    }
    array_free(list);
    return node;
}


#line 79 "read_eqn.y"
typedef union {
    char *strval;
    node_t *node;
    array_t *array;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		70
#define	YYFLAG		-32768
#define	YYNTBASE	21

#define YYTRANSLATE(x) ((unsigned)(x) <= 275 ? yytranslate[x] : 30)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     3,     7,     9,    12,    16,    17,    21,    25,
    29,    33,    39,    43,    47,    50,    54,    58,    61,    64,
    66,    68,    72,    74,    79,    84,    89,    91,    93,    97,
   101,   103,   105,   108,   110,   111,   114,   115
};

static const short yyrhs[] = {    -1,
    22,     0,    22,    20,    18,     0,    25,     0,    23,    18,
     0,    22,    23,    18,     0,     0,    13,    17,    27,     0,
    14,    17,    28,     0,    15,    17,    29,     0,    27,    17,
    24,     0,     8,    17,    27,    25,    19,     0,    24,     3,
    24,     0,    24,     4,    24,     0,    24,    24,     0,    24,
     9,    24,     0,    24,    10,    24,     0,    24,    12,     0,
    11,    24,     0,     5,     0,     6,     0,     8,    24,    19,
     0,    27,     0,     8,     4,    26,    19,     0,     8,     3,
    26,    19,     0,     8,    11,    25,    19,     0,     5,     0,
     6,     0,     8,     5,    19,     0,     8,     6,    19,     0,
    27,     0,    25,     0,    26,    25,     0,     7,     0,     0,
    28,    27,     0,     0,    29,    27,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    96,    97,    98,    99,   103,   104,   107,   108,   114,   116,
   118,   121,   126,   129,   132,   135,   138,   141,   144,   147,
   150,   153,   156,   166,   169,   172,   175,   178,   181,   184,
   187,   197,   202,   207,   212,   213,   230,   231
};

static const char * const yytname[] = {   "$","error","$illegal.","OPR_OR","OPR_AND",
"CONST_ZERO","CONST_ONE","IDENTIFIER","LPAREN","OPR_XOR","OPR_XNOR","OPR_NOT",
"OPR_NOT_POST","NAME","INORDER","OUTORDER","PASS","ASSIGN","SEMI","RPAREN","END",
"program","prog","stat","expr","sexpr","sexpr_list","identifier","input_list",
"output_list",""
};
#endif

static const short yyr1[] = {     0,
    21,    21,    21,    21,    22,    22,    23,    23,    23,    23,
    23,    23,    24,    24,    24,    24,    24,    24,    24,    24,
    24,    24,    24,    25,    25,    25,    25,    25,    25,    25,
    25,    26,    26,    27,    28,    28,    29,    29
};

static const short yyr2[] = {     0,
     0,     1,     3,     1,     2,     3,     0,     3,     3,     3,
     3,     5,     3,     3,     2,     3,     3,     2,     2,     1,
     1,     3,     1,     4,     4,     4,     1,     1,     3,     3,
     1,     1,     2,     1,     0,     2,     0,     2
};

static const short yydefact[] = {     1,
    27,    28,    34,     0,     0,     0,     0,     2,     0,     4,
    31,     0,     0,     0,     0,     0,     0,     0,    35,    37,
     0,     0,     0,     0,     5,     0,     0,    32,     0,    31,
     0,    29,    30,     0,     0,     8,     9,    10,     3,     6,
    20,    21,     0,     0,    11,    23,    25,    33,    24,    26,
     0,    36,    38,     0,    19,     0,     0,     0,     0,    18,
    15,    12,    22,    13,    14,    16,    17,     0,     0,     0
};

static const short yydefgoto[] = {    68,
     8,     9,    61,    28,    29,    46,    37,    38
};

static const short yypact[] = {    -4,
-32768,-32768,-32768,    56,     2,     3,     6,    70,     4,-32768,
     7,    36,    36,    11,    44,    36,    57,    57,-32768,-32768,
    49,    54,    58,     7,-32768,   109,   107,-32768,    20,-32768,
    63,-32768,-32768,    55,    36,-32768,    57,    57,-32768,-32768,
-32768,-32768,   109,   109,    88,-32768,-32768,-32768,-32768,-32768,
    60,-32768,-32768,    46,-32768,   109,   109,   109,   109,-32768,
   112,-32768,-32768,    97,   112,    -5,    -5,    75,    80,-32768
};

static const short yypgoto[] = {-32768,
-32768,    73,   -11,     5,    74,     0,-32768,-32768
};


#define	YYLAST		124


static const short yytable[] = {    11,
     1,     2,     3,     4,    10,    44,    60,    24,     5,     6,
     7,    30,    30,    -7,    45,    30,    35,    36,    18,    19,
    34,    25,    20,    26,     1,     2,     3,    27,    30,    32,
    30,    54,    55,    48,    30,    48,    52,    53,    47,    51,
     1,     2,     3,    27,    64,    65,    66,    67,    56,    57,
    41,    42,     3,    43,    58,    59,    44,    60,    12,    13,
    14,    15,    33,     3,    63,    17,    16,     1,     2,     3,
    27,    39,    17,    50,    69,    40,     3,    21,    62,    70,
    23,    49,     5,     6,     7,     0,    31,    -7,     0,    22,
    56,    57,    41,    42,     3,    43,    58,    59,    44,    60,
    57,    41,    42,     3,    43,    58,    59,    44,    60,    12,
    13,    14,    15,    41,    42,     3,    43,    16,     0,    44,
    58,    59,    44,    60
};

static const short yycheck[] = {     0,
     5,     6,     7,     8,     0,    11,    12,     8,    13,    14,
    15,    12,    13,    18,    26,    16,    17,    18,    17,    17,
    16,    18,    17,    17,     5,     6,     7,     8,    29,    19,
    31,    43,    44,    29,    35,    31,    37,    38,    19,    35,
     5,     6,     7,     8,    56,    57,    58,    59,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,     3,     4,
     5,     6,    19,     7,    19,    17,    11,     5,     6,     7,
     8,    18,    17,    19,     0,    18,     7,     8,    19,     0,
     8,    19,    13,    14,    15,    -1,    13,    18,    -1,    20,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
     4,     5,     6,     7,     8,     9,    10,    11,    12,     3,
     4,     5,     6,     5,     6,     7,     8,    11,    -1,    11,
     9,    10,    11,    12
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 4:
#line 100 "read_eqn.y"
{ do_assign(util_strsav("SILLY"), yyvsp[0].node); ;
    break;}
case 8:
#line 109 "read_eqn.y"
{
			network_set_name(global_network, yyvsp[0].strval);
			FREE(yyvsp[0].strval);
		    ;
    break;}
case 11:
#line 119 "read_eqn.y"
{ do_assign(yyvsp[-2].strval, yyvsp[0].node); ;
    break;}
case 12:
#line 122 "read_eqn.y"
{ do_assign(yyvsp[-2].strval, yyvsp[-1].node); ;
    break;}
case 13:
#line 127 "read_eqn.y"
{ yyval.node = node_or(yyvsp[-2].node, yyvsp[0].node); node_free(yyvsp[-2].node); node_free(yyvsp[0].node);;
    break;}
case 14:
#line 130 "read_eqn.y"
{ yyval.node = node_and(yyvsp[-2].node, yyvsp[0].node); node_free(yyvsp[-2].node); node_free(yyvsp[0].node);;
    break;}
case 15:
#line 133 "read_eqn.y"
{ yyval.node = node_and(yyvsp[-1].node, yyvsp[0].node); node_free(yyvsp[-1].node); node_free(yyvsp[0].node);;
    break;}
case 16:
#line 136 "read_eqn.y"
{ yyval.node = node_xor(yyvsp[-2].node, yyvsp[0].node); node_free(yyvsp[-2].node); node_free(yyvsp[0].node);;
    break;}
case 17:
#line 139 "read_eqn.y"
{ yyval.node = node_xnor(yyvsp[-2].node, yyvsp[0].node); node_free(yyvsp[-2].node); node_free(yyvsp[0].node);;
    break;}
case 18:
#line 142 "read_eqn.y"
{ yyval.node = node_not(yyvsp[-1].node); node_free(yyvsp[-1].node); ;
    break;}
case 19:
#line 145 "read_eqn.y"
{ yyval.node = node_not(yyvsp[0].node); node_free(yyvsp[0].node); ;
    break;}
case 20:
#line 148 "read_eqn.y"
{ yyval.node = node_constant(0); ;
    break;}
case 21:
#line 151 "read_eqn.y"
{ yyval.node = node_constant(1); ;
    break;}
case 22:
#line 154 "read_eqn.y"
{ yyval.node = yyvsp[-1].node; ;
    break;}
case 23:
#line 157 "read_eqn.y"
{
			node_t *node;
			node = read_find_or_create_node(global_network, yyvsp[0].strval);
			yyval.node = node_literal(node, 1);
			FREE(yyvsp[0].strval);
		    ;
    break;}
case 24:
#line 167 "read_eqn.y"
{ yyval.node = do_sexpr_list(yyvsp[-1].array, node_and); ;
    break;}
case 25:
#line 170 "read_eqn.y"
{ yyval.node = do_sexpr_list(yyvsp[-1].array, node_or); ;
    break;}
case 26:
#line 173 "read_eqn.y"
{ yyval.node = node_not(yyvsp[-1].node); node_free(yyvsp[-1].node); ;
    break;}
case 27:
#line 176 "read_eqn.y"
{ yyval.node = node_constant(0); ;
    break;}
case 28:
#line 179 "read_eqn.y"
{ yyval.node = node_constant(1); ;
    break;}
case 29:
#line 182 "read_eqn.y"
{ yyval.node = node_constant(0); ;
    break;}
case 30:
#line 185 "read_eqn.y"
{ yyval.node = node_constant(1); ;
    break;}
case 31:
#line 188 "read_eqn.y"
{
			node_t *node;
			node = read_find_or_create_node(global_network, yyvsp[0].strval);
			yyval.node = node_literal(node, 1);
			FREE(yyvsp[0].strval);
		    ;
    break;}
case 32:
#line 198 "read_eqn.y"
{
			yyval.array = array_alloc(node_t *, 10);
			array_insert_last(node_t *, yyval.array, yyvsp[0].node);
		    ;
    break;}
case 33:
#line 203 "read_eqn.y"
{
			array_insert_last(node_t *, yyvsp[-1].array, yyvsp[0].node);
		    ;
    break;}
case 34:
#line 208 "read_eqn.y"
{ yyval.strval = util_strsav(yytext); ;
    break;}
case 36:
#line 214 "read_eqn.y"
{
			node_t *node;
			char errmsg[1024];
			node = read_find_or_create_node(global_network, yyvsp[0].strval);
			if (node_function(node) != NODE_UNDEFINED) {
			    (void) sprintf(errmsg, 
				"Attempt to redefine '%s'\n", yyvsp[0].strval);
			    yyerror(errmsg);   /* never returns */
			}
			network_change_node_type(global_network, 
							node, PRIMARY_INPUT);
			FREE(yyvsp[0].strval);
		    ;
    break;}
case 38:
#line 232 "read_eqn.y"
{
			node_t *node;
			node = read_find_or_create_node(global_network, yyvsp[0].strval);
			LS_ASSERT(lsNewEnd(po_list, (lsGeneric) node, LS_NH));
			FREE(yyvsp[0].strval);
		    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 240 "read_eqn.y"


#include "eqnlex.c"

static char *string;
static int file_mode;
static int nbuffer;
static char buffer[20];
static int last_was_newline;
static jmp_buf jmpbuf;

#ifndef FLEX_SCANNER
static int
input()
{
    register int c;
    register char *prompt;

    if (nbuffer > 0) {
	c = buffer[--nbuffer];
    } else if (file_mode) {
	if (last_was_newline && yyin == stdin) {
	    prompt = com_get_flag("prompt2");
	    if (prompt != NULL) fputs(prompt,stdout);
	}
	c = getc(yyin);
    } else {
	c = *string;
	if (c != 0) string++;
    }

    last_was_newline = (c == '\n');
    if (last_was_newline) read_lineno++;
    if (c == EOF) c = 0;
    return c;
}

static int
unput(c)
int c;
{
    if (nbuffer < 20) buffer[nbuffer++] = c;
    if (c == '\n') read_lineno--;
}
#else

char *eqn_inp_ptr;
char* eqn_inp_lim;

int eqn_input(char* buf, int max_size)
{
    char c;
    int i, n;
	 
    if (! file_mode) {
	if (max_size > (eqn_inp_lim - eqn_inp_ptr))
	    n = eqn_inp_lim - eqn_inp_ptr;
	else
	    n= max_size;
	if (n > 0) {
	    for (i = 0; i < n; i++)
		if (eqn_inp_ptr[i] == '\n') {
		    read_lineno++;
		    i++;
		    break;
		}
	    memcpy (buf, eqn_inp_ptr, i);
	    eqn_inp_ptr += i;
	}
    } else {
	c = getc(yyin);
	if (c == '\n')
	    read_lineno++;
	buf[0] = (c == EOF) ? (n = 0, YY_NULL) : (n = 1, c);
    }
    return n;
}

#endif

static int
equation_setup_string(s)
char *s;
{
    read_register_filename(NIL(char));
    file_mode = 0;
    string = s;
#ifdef FLEX_SCANNER
    yy_switch_to_buffer(
                 yy_create_buffer( yyin, YY_BUF_SIZE ) );
    yyrestart(yyin); 
    eqn_inp_lim = string + strlen(string);
    eqn_inp_ptr = string;
#endif
    nbuffer = 0;
}


static int
equation_setup_file(fp)
FILE *fp;
{
    yyin = fp;
#ifdef FLEX_SCANNER
    yy_switch_to_buffer(
                 yy_create_buffer( yyin, YY_BUF_SIZE ) );
    yyrestart(yyin); 
    BEGIN(INITIAL);
#endif
    file_mode = 1;
    nbuffer = 0;
    last_was_newline = 1;
}


static int
yyerror(errmsg)
char *errmsg;
{
    read_error(errmsg);
    longjmp(jmpbuf, 1);
}

#undef yywrap
static int
yywrap()
{
    return 1;
}


network_t *
read_eqn(fp)
FILE *fp;
{
    error_init();

    if (setjmp(jmpbuf)) {
	/* syntax error -- return from yyerror() */
	LS_ASSERT(lsDestroy(po_list, (void (*)()) 0));
	network_free(global_network);
	return 0;

    } else {
	global_network = network_alloc();
	read_filename_to_netname(global_network, read_filename);
	po_list = lsCreate();
	equation_setup_file(fp);
	(void) yyparse();

	if (!read_check_io_list(global_network, po_list)) {
	    network_free(global_network);
	    return 0;
	}
	read_hack_outputs(global_network, po_list);
	LS_ASSERT(lsDestroy(po_list, (void (*)()) 0));

	if (! network_is_acyclic(global_network)) {
	    network_free(global_network);
	    return 0;
	}

	return global_network;
    }
}

network_t *
read_eqn_string(s)
char *s;
{
    error_init();

    if (setjmp(jmpbuf)) {
	/* syntax error -- return from yyerror() */
	LS_ASSERT(lsDestroy(po_list, (void (*)()) 0));
	network_free(global_network);
	return 0;

    } else {
	global_network = network_alloc();
	po_list = lsCreate();
	equation_setup_string(s);
	(void) yyparse();

	if (!read_check_io_list(global_network, po_list)) {
	    network_free(global_network);
	    return 0;
	}
	read_hack_outputs(global_network, po_list);
	LS_ASSERT(lsDestroy(po_list, (void (*)()) 0));

	if (! network_is_acyclic(global_network)) {
	    network_free(global_network);
	    return 0;
	}

	return global_network;
    }
}
